package code;

import text.*;

public class Code {

	public static String tempReg( int reg ) {
		return "$t" + reg;
		}

	public static String argReg( int reg ) {
		return "$a" + reg;
		}

	public static String literal( int value ) {
		return "" + value;
		}

	public static String literal( boolean value ) {
		if ( value )
			return "1";
		else
			return "0";
		}

	public static String indirect( int reg ) {
		return "(" + tempReg( reg ) + ")";
		}

	public static void enter() {
		Print.compile().println( "{%+" );
		}

	public static void exit() {
		Print.compile().println( "%-}" );
		}

	public static void enter( String segment ) {
		Print.compile().println( segment + " {%+" );
		}

	public static void exit(  String segment ) {
		Print.compile().println( "%-} " + segment );
		}

	public static void enterBlock( String name, String extending, String using ) {
		String result = "public block " + name;
		if ( extending != null )
			result += " extends " + extending;
		if ( using != null )
			result += " uses " + using;
		result += " {%+";
		Print.compile().println( result );
		}

	public static void exitBlock(  String name ) {
		Print.compile().println( "%-} block " + name );
		}

	public static void instrn( String opCode ) {
		if ( opCode == null )
			throw new Error( "null opCode" );
		Print.compile().println( opCode + ";" );
		}

	public static void instrn( String opCode, String opd1 ) {
		if ( opCode == null )
			throw new Error( "null opCode" );
		Print.compile().println( opCode + " " + opd1 + ";" );
		}

	public static void instrn( String opCode, String opd1, String opd2 ) {
		if ( opCode == null )
			throw new Error( "null opCode" );
		Print.compile().println( opCode + " " + opd1 + ", " + opd2 + ";" );
		}

	public static void instrn( String opCode, String opd1, String opd2, String opd3 ) {
		if ( opCode == null )
			throw new Error( "null opCode" );
		Print.compile().println( opCode + " " + opd1 + ", " + opd2 + ", " + opd3 + ";" );
		}

	public static void importFile( String fileName ) {
		instrn( "import", "\"" + fileName + "\"" );
		}

	public static void labelDefn( String label ) {
		Print.compile().println( "%-" + label + ":%+" );
		}

	public static void publicLabelDefn( String label ) {
		Print.compile().println( "%-public " + label + ":%+" );
		}

	public static void asciiz( String data ) {
		instrn( "asciiz", "\"" + Convert.toFormatString( data ) + "\"" );
		instrn( "align" );
		}

	public static void quad( int value ) {
		instrn( "quad", literal( value ) );
		}

	}
	