package node.exprNode.valueNode;

import text.*;
import env.*;
import code.*;
import node.exprNode.*;

public class StringValueNode extends ValueNode {

	private String value;

	public StringValueNode( String value ) {
		this.value = value;
		precedence = PREC_PRIMARY;
		}

	public String toString() {
		return "\"" + Convert.toFormatString( value ) + "\"";
		}

	public void evalCode( int freeReg ) {
		Code.enter();
		Code.enter( "const" );
		Code.labelDefn( "string" );
		Code.asciiz( value );
		Code.exit( "const" );
		Code.instrn( "ldiq", Code.tempReg( freeReg ), "string" );
		Code.exit();
		}
		
	}
