package node.stmtNode;

import env.*;
import code.*;
import node.exprNode.*;

public class AssignStmtNode extends StmtNode {

	private String ident;
	private ExprNode expr;

	public AssignStmtNode( String ident, ExprNode expr ) {
		this.ident = ident;
		this.expr = expr;
		}

	public String toString() {
		return ident + " = " + expr +";";
		}

	public void genDeclCode( Env env ) {
		env.add( ident );
		}
		
	public void genCode() {
		Code.enter();
		Code.instrn( "ldiq", "$t0", ident );
		expr.evalCode( 1 );
		Code.instrn( "stq", "$t1", "($t0)" );
		Code.exit();
		}
	}
