package node.stmtNode;

import env.*;
import code.*;

import node.exprNode.*;

public class IfThenElseStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtNode thenPart;
	private StmtNode elsePart;

	public IfThenElseStmtNode( 
		ExprNode cond, 
		StmtNode thenPart, 
		StmtNode elsePart ) {
		this.cond = cond;
		this.thenPart = thenPart;
		this.elsePart = elsePart;
		}

	public String toString() {
		return "if " + cond + " then%+%n" 
			+ thenPart + "%-%nelse%+%n" + elsePart + "%-";
		}

	public void genDeclCode( Env env ) {
		thenPart.genDeclCode( env );
		elsePart.genDeclCode( env );
		}
		
	public void genCode() {
		Code.enter();
		Code.labelDefn( "if" );
		cond.evalCode( 0 );
		Code.instrn( "blbc", "$t0", "else" );
		Code.labelDefn( "then" );
		thenPart.genCode();
		Code.instrn( "br", "end" );
		Code.labelDefn( "else" );
		elsePart.genCode();
		Code.labelDefn( "end" );
		Code.exit();
		}

	}
