package node.stmtNode;

import env.*;
import code.*;

import node.exprNode.*;

public class IfThenStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtNode thenPart;

	public IfThenStmtNode( ExprNode cond, StmtNode thenPart ) {
		this.cond = cond;
		this.thenPart = thenPart;
		}

	public String toString() {
		return "if " + cond + " then%+%n" + thenPart + "%-";
		}

	public void genDeclCode( Env env ) {
		thenPart.genDeclCode( env );
		}
		
	public void genCode() {
		Code.enter();
		Code.labelDefn( "if" );
		cond.evalCode( 0 );
		Code.instrn( "blbc", "$t0", "end" );
		Code.labelDefn( "then" );
		thenPart.genCode();
		Code.labelDefn( "end" );
		Code.exit();
		}

	}
